'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Spice = exports.status = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _koaSocket = require('koa-socket');

var _koaSocket2 = _interopRequireDefault(_koaSocket);

var _Event = require('./events/Event');

var _Event2 = _interopRequireDefault(_Event);

var _SpiceModel = require('./models/SpiceModel');

var _SpiceModel2 = _interopRequireDefault(_SpiceModel);

var _Crypt = require('./utility/Crypt');

var _Crypt2 = _interopRequireDefault(_Crypt);

var _Serializer = require('./utility/Serializer');

var _Serializer2 = _interopRequireDefault(_Serializer);

var _RestHelper = require('./utility/RestHelper');

var _RestHelper2 = _interopRequireDefault(_RestHelper);

var _status = require('../cli/lib/status');

var _status2 = _interopRequireDefault(_status);

var _Mail = require('./mail/Mail');

var _Mail2 = _interopRequireDefault(_Mail);

var _Debug = require('./mail/providers/Debug');

var _Debug2 = _interopRequireDefault(_Debug);

var _File = require('./mail/providers/File');

var _File2 = _interopRequireDefault(_File);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var path = require('path');

var cors = require('kcors');
var io = new _koaSocket2.default();
global.spice = {};

require('dotenv').config();

var validate = require('koa-validation');
var bodyParser = require('koa-bodyparser');
var koaBody = require('koa-body');
spice.root_path = path.resolve('./build/');
spice.module_root_path = path.resolve(__dirname);


var convert = require('koa-convert');

spice.classes = {};
spice.classes.Event = _Event2.default;
spice.classes.Model = _SpiceModel2.default;
spice.classes.Crypt = _Crypt2.default;
spice.classes.Serializer = _Serializer2.default;
spice.classes.RestHelper = _RestHelper2.default;
spice.classes.validate = validate;
spice.classes.Mail = _Mail2.default;
spice.classes.mail = { providers: {} };
spice.classes.mail.providers.Debug = _Debug2.default;
spice.classes.mail.providers.File = _File2.default;
var status = exports.status = _status2.default;

var Spice = exports.Spice = function () {
    function Spice() {
        _classCallCheck(this, Spice);
    }

    _createClass(Spice, [{
        key: 'init',
        value: function () {
            var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(app) {
                return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                _context.prev = 0;

                                app.use(cors());
                                require('koa-qs')(app, 'extended');
                                app.use(koaBody({ formLimit: "1gb", multipart: true, formidable: { uploadDir: './storage/uploads' } }));
                                app.use(convert(validate()));
                                spice.app = app;
                                _context.next = 8;
                                return require('./loaders/config')();

                            case 8:
                                spice.config = _context.sent;

                                spice.io = io;
                                require('./loaders');
                                io.attach(app);
                                return _context.abrupt('return', spice);

                            case 15:
                                _context.prev = 15;
                                _context.t0 = _context['catch'](0);

                                console.log(_context.t0.stack);

                            case 18:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this, [[0, 15]]);
            }));

            function init(_x) {
                return _ref.apply(this, arguments);
            }

            return init;
        }()
    }, {
        key: 'init_spa',
        value: function () {
            var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(vue) {
                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                    while (1) {
                        switch (_context2.prev = _context2.next) {
                            case 0:
                                try {
                                    window.spice = {};
                                    //window.config = await require('./loaders/config')();
                                } catch (e) {
                                    console.log(e.stack);
                                }

                            case 1:
                            case 'end':
                                return _context2.stop();
                        }
                    }
                }, _callee2, this);
            }));

            function init_spa(_x2) {
                return _ref2.apply(this, arguments);
            }

            return init_spa;
        }()
    }]);

    return Spice;
}();

exports.default = Spice;