'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var ordered_modules = ['logger', 'error', 'database', 'views'];
exports.default = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    var bootstrap_path, app_bootstrap_path, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, file, mod, paths, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, loadder_path, _iteratorNormalCompletion3, _didIteratorError3, _iteratorError3, _iterator3, _step3, _file, _mod;

    return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
            switch (_context.prev = _context.next) {
                case 0:
                    _context.prev = 0;

                    /*console.log('loading from array')*/
                    bootstrap_path = _path2.default.resolve(_path2.default.join(spice.module_root_path, '/bootstrap'));
                    app_bootstrap_path = _path2.default.resolve(_path2.default.join(spice.root_path, '/bootstrap'));
                    /*console.log('Bootstrap directory', bootstrap_path);*/

                    _iteratorNormalCompletion = true;
                    _didIteratorError = false;
                    _iteratorError = undefined;
                    _context.prev = 6;
                    _iterator = ordered_modules[Symbol.iterator]();

                case 8:
                    if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                        _context.next = 18;
                        break;
                    }

                    file = _step.value;
                    mod = require(_path2.default.join(bootstrap_path, file));

                    if (!_lodash2.default.isFunction(mod)) {
                        _context.next = 14;
                        break;
                    }

                    _context.next = 14;
                    return mod();

                case 14:
                    console.log('loaded', file);

                case 15:
                    _iteratorNormalCompletion = true;
                    _context.next = 8;
                    break;

                case 18:
                    _context.next = 24;
                    break;

                case 20:
                    _context.prev = 20;
                    _context.t0 = _context['catch'](6);
                    _didIteratorError = true;
                    _iteratorError = _context.t0;

                case 24:
                    _context.prev = 24;
                    _context.prev = 25;

                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }

                case 27:
                    _context.prev = 27;

                    if (!_didIteratorError) {
                        _context.next = 30;
                        break;
                    }

                    throw _iteratorError;

                case 30:
                    return _context.finish(27);

                case 31:
                    return _context.finish(24);

                case 32:
                    paths = [bootstrap_path, app_bootstrap_path];
                    _iteratorNormalCompletion2 = true;
                    _didIteratorError2 = false;
                    _iteratorError2 = undefined;
                    _context.prev = 36;
                    _iterator2 = paths[Symbol.iterator]();

                case 38:
                    if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                        _context.next = 72;
                        break;
                    }

                    loadder_path = _step2.value;

                    /*console.log('loading from directory');*/
                    _iteratorNormalCompletion3 = true;
                    _didIteratorError3 = false;
                    _iteratorError3 = undefined;
                    _context.prev = 43;
                    _iterator3 = _fs2.default.readdirSync(loadder_path)[Symbol.iterator]();

                case 45:
                    if (_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done) {
                        _context.next = 55;
                        break;
                    }

                    _file = _step3.value;

                    if (!(_file != 'index.js' && !_lodash2.default.includes(ordered_modules, _file.split('.')[0]))) {
                        _context.next = 52;
                        break;
                    }

                    _mod = require(_path2.default.join(loadder_path, _file.split('.')[0]));

                    if (!_lodash2.default.isFunction(_mod)) {
                        _context.next = 52;
                        break;
                    }

                    _context.next = 52;
                    return _mod();

                case 52:
                    _iteratorNormalCompletion3 = true;
                    _context.next = 45;
                    break;

                case 55:
                    _context.next = 61;
                    break;

                case 57:
                    _context.prev = 57;
                    _context.t1 = _context['catch'](43);
                    _didIteratorError3 = true;
                    _iteratorError3 = _context.t1;

                case 61:
                    _context.prev = 61;
                    _context.prev = 62;

                    if (!_iteratorNormalCompletion3 && _iterator3.return) {
                        _iterator3.return();
                    }

                case 64:
                    _context.prev = 64;

                    if (!_didIteratorError3) {
                        _context.next = 67;
                        break;
                    }

                    throw _iteratorError3;

                case 67:
                    return _context.finish(64);

                case 68:
                    return _context.finish(61);

                case 69:
                    _iteratorNormalCompletion2 = true;
                    _context.next = 38;
                    break;

                case 72:
                    _context.next = 78;
                    break;

                case 74:
                    _context.prev = 74;
                    _context.t2 = _context['catch'](36);
                    _didIteratorError2 = true;
                    _iteratorError2 = _context.t2;

                case 78:
                    _context.prev = 78;
                    _context.prev = 79;

                    if (!_iteratorNormalCompletion2 && _iterator2.return) {
                        _iterator2.return();
                    }

                case 81:
                    _context.prev = 81;

                    if (!_didIteratorError2) {
                        _context.next = 84;
                        break;
                    }

                    throw _iteratorError2;

                case 84:
                    return _context.finish(81);

                case 85:
                    return _context.finish(78);

                case 86:
                    _context.next = 91;
                    break;

                case 88:
                    _context.prev = 88;
                    _context.t3 = _context['catch'](0);

                    console.log(_context.t3.stack);

                case 91:
                case 'end':
                    return _context.stop();
            }
        }
    }, _callee, this, [[0, 88], [6, 20, 24, 32], [25,, 27, 31], [36, 74, 78, 86], [43, 57, 61, 69], [62,, 64, 68], [79,, 81, 85]]);
}))();