'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var nunjucksRender = require('koa-nunjucks-render2');
var path = require("path");
var convert = require('koa-convert');
var juice = require('juice');

var Mail = function () {
    function Mail() {
        var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        _classCallCheck(this, Mail);

        this.nunjucksOptions = {
            ext: spice.config.spice.view.ext || '.html',
            noCache: true,
            throwOnUndefined: false,
            globals: spice.config.spice.view.globals,
            filters: spice.config.spice.view.filters
        };

        if (spice.config.spice.view.custom_tags.enabled == true) {
            this.nunjucksOptions.tags = {
                variableStart: spice.config.spice.view.custom_tags.start || '${',
                variableEnd: spice.config.spice.view.custom_tags.end || '}'
            };
        }

        this.driver_name = args.driver_name || spice.config.mail.default_driver;
        this.driver_options = _lodash2.default.merge(spice.config.mail.drivers[this.driver_name], args.driver_options);
        this.template = args.template;
        this.Driver = spice.config.mail.providers[this.driver_name];
    }

    _createClass(Mail, [{
        key: 'prepare',
        value: function () {
            var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(data) {
                var obj;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                //apply template here
                                obj = {};

                                nunjucksRender(path.resolve('./core/client/resource/views'), this.nunjucksOptions)(obj, function () {});
                                _context.next = 4;
                                return obj.render(this.template, data);

                            case 4:
                                return _context.abrupt('return', obj.body);

                            case 5:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function prepare(_x2) {
                return _ref.apply(this, arguments);
            }

            return prepare;
        }()
    }, {
        key: 'send',
        value: function () {
            var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref3) {
                var data = _ref3.data,
                    options = _ref3.options,
                    template = _ref3.template,
                    content = _ref3.content,
                    driver_options = _ref3.driver_options;
                var sendable_text, driver;
                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                    while (1) {
                        switch (_context2.prev = _context2.next) {
                            case 0:
                                if (template) {
                                    this.template = template;
                                }
                                if (driver_options) {
                                    this.driver_options = _lodash2.default.merge(this.driver_options, driver_options);
                                }
                                sendable_text = "";

                                if (!this.template) {
                                    _context2.next = 7;
                                    break;
                                }

                                _context2.next = 6;
                                return this.prepare(_extends({}, data, this));

                            case 6:
                                sendable_text = _context2.sent;

                            case 7:

                                if (content) {
                                    sendable_text = content;
                                }

                                driver = new this.Driver(this.driver_options);
                                _context2.next = 11;
                                return driver.send(juice(sendable_text), options);

                            case 11:
                                return _context2.abrupt('return', _context2.sent);

                            case 12:
                            case 'end':
                                return _context2.stop();
                        }
                    }
                }, _callee2, this);
            }));

            function send(_x3) {
                return _ref2.apply(this, arguments);
            }

            return send;
        }()
    }]);

    return Mail;
}();

exports.default = Mail;