'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var fs = require('fs-extra');
var path = require('path');
var open = require("open");

var File = function () {
    function File() {
        var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        _classCallCheck(this, File);

        this.sender = args.sender;
        this.subject = args.subject;
        this.htmlText = args.htmlText;
        this.dest = path.join(path.resolve('./'), 'storage/mail');
        if (args.path) {
            this.dest = path.resolve(args.path);
        }
    }

    _createClass(File, [{
        key: 'send',
        value: function () {
            var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(htmlText) {
                var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
                var email, time, full_path;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                email = {
                                    to: options.to,
                                    from: options.sender || this.sender,
                                    subject: options.subject || this.subject,
                                    htmlText: htmlText || this.htmlText
                                };
                                time = new Date().getTime();

                                fs.ensureDirSync(this.dest + '/' + email.subject + '/' + time);
                                full_path = this.dest + '/' + email.subject + '/' + time + '/to:' + email.to + ' from:' + email.from + '.html';

                                fs.writeFileSync(full_path, email.htmlText);
                                open(full_path);

                            case 6:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function send(_x2) {
                return _ref.apply(this, arguments);
            }

            return send;
        }()
    }]);

    return File;
}();

exports.default = File;