"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var regeneratorRuntime = require('regenerator-runtime');
var SDate = require('sonover-date'),
    UUID = require('uuid'),
    _ = require('lodash'),
    _database = Symbol(),
    _props = Symbol();

var SpiceModel = function () {
	function SpiceModel() {
		var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		_classCallCheck(this, SpiceModel);

		try {
			var dbtype = spice.config.database.connections[args.connection].type || "couchbase";
			var Database = require('spice-' + dbtype);
			this.type = "";
			this.deleted = false;
			if (args.args) {
				delete args.args['ctx'];
			}
			this[_database] = new Database(args.connection || 'default');
			this[_props] = args.props;
			for (var i in args.props) {
				if (args.args != undefined) {
					if (args.args[i] != undefined) {
						switch (args.props[i].type) {
							case 'string':
								{
									this[i] = args.args[i];
									break;
								}
							case 'number':
								{
									this[i] = _.isNumber(args.args[i]) ? args.args[i] : Number(args.args[i]);
									break;
								}
							case 'boolean':
								{
									this[i] = _.isBoolean(args.args[i]) ? args.args[i] : args.args[i] == 'true';
									break;
								}
							case 'date':
								{
									this[i] = args.args[i];
									break;
								}
							case 'array':
								{
									this[i] = _.isArray(args.args[i]) ? args.args[i] : JSON.parse(args.args[i]);
									break;
								}
							case 'object':
								{
									//console.log(args.args[i])
									this[i] = _.isObject(args.args[i]) ? args.args[i] : JSON.parse(args.args[i]);
									break;
								}
							default:
								{
									this[i] = args.args[i];
								}
						}
					}
				}
			}
		} catch (e) {
			console.log(e.stack);
		}
		//}
	}

	_createClass(SpiceModel, [{
		key: 'is_date',
		value: function is_date(item) {
			return item.length > 27 && item.indexOf("|") > -1;
		}
	}, {
		key: 'makeQueryFromFilter',
		value: function makeQueryFromFilter(filter) {
			var return_string = "";
			for (var key in filter) {
				var item_string = "";
				if (filter[key].length > 1) {
					item_string = "(";
				}

				var item_count = 0;

				var _iteratorNormalCompletion = true;
				var _didIteratorError = false;
				var _iteratorError = undefined;

				try {
					for (var _iterator = filter[key][Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
						var item = _step.value;


						if (item_count > 0) {
							item_string = item_string + " OR ";
						}

						if (this.is_date(item)) {
							var to_index = item.indexOf("|");
							var first = item.substring(0, to_index);
							var second = item.substring(to_index + 1, item.length);
							item_string = item_string + " " + key + " BETWEEN '" + first + "' AND '" + second + "'";
						} else {
							item_string = item_string + " " + key + " LIKE '" + item + "'";
						}

						item_count++;
					}
				} catch (err) {
					_didIteratorError = true;
					_iteratorError = err;
				} finally {
					try {
						if (!_iteratorNormalCompletion && _iterator.return) {
							_iterator.return();
						}
					} finally {
						if (_didIteratorError) {
							throw _iteratorError;
						}
					}
				}

				if (filter[key].length > 1) {
					item_string = item_string + ")";
				}
				if (return_string != "") {
					return_string = return_string + " AND ";
				}
				return_string = return_string + item_string;
			}
			return return_string;
		}
	}, {
		key: 'get',
		value: function () {
			var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(args) {
				var results;
				return regeneratorRuntime.wrap(function _callee$(_context) {
					while (1) {
						switch (_context.prev = _context.next) {
							case 0:
								_context.prev = 0;

								if (!args) {
									args = {};
								}

								if (!_.isString(args.id)) {
									_context.next = 20;
									break;
								}

								_context.next = 5;
								return this.run_hook(args, 'get', 'before');

							case 5:
								_context.next = 7;
								return this.database.get(args.id);

							case 7:
								results = _context.sent;


								console.log(results);

								if (!(results.type != this.type)) {
									_context.next = 11;
									break;
								}

								throw new Error(this.type + ' does not exist');

							case 11:
								if (!(results.deleted == undefined || results.deleted == false)) {
									_context.next = 19;
									break;
								}

								_context.next = 14;
								return this.run_hook(results, 'get', 'after');

							case 14:
								_context.next = 16;
								return this.do_serialize(results, 'read', {}, args);

							case 16:
								return _context.abrupt('return', results);

							case 19:
								throw new Error(this.type + ' does not exist');

							case 20:
								_context.next = 25;
								break;

							case 22:
								_context.prev = 22;
								_context.t0 = _context['catch'](0);
								throw _context.t0;

							case 25:
							case 'end':
								return _context.stop();
						}
					}
				}, _callee, this, [[0, 22]]);
			}));

			function get(_x2) {
				return _ref.apply(this, arguments);
			}

			return get;
		}()
	}, {
		key: 'query',
		value: function () {
			var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_query) {
				var results;
				return regeneratorRuntime.wrap(function _callee2$(_context2) {
					while (1) {
						switch (_context2.prev = _context2.next) {
							case 0:
								_context2.prev = 0;
								_context2.next = 3;
								return this.database.query(_query);

							case 3:
								results = _context2.sent;
								return _context2.abrupt('return', results);

							case 7:
								_context2.prev = 7;
								_context2.t0 = _context2['catch'](0);
								throw _context2.t0;

							case 10:
							case 'end':
								return _context2.stop();
						}
					}
				}, _callee2, this, [[0, 7]]);
			}));

			function query(_x3) {
				return _ref2.apply(this, arguments);
			}

			return query;
		}()
	}, {
		key: 'getMulti',
		value: function () {
			var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(args) {
				var _this = this;

				var results, removed, _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, i, _i;

				return regeneratorRuntime.wrap(function _callee3$(_context3) {
					while (1) {
						switch (_context3.prev = _context3.next) {
							case 0:
								_context3.prev = 0;

								if (!args) {
									args = {};
								}

								_context3.next = 4;
								return this.run_hook(this, 'get', 'before');

							case 4:
								_.remove(args.ids, function (o) {
									return o == undefined;
								});
								results = [];

								if (!(args.ids.length > 0)) {
									_context3.next = 10;
									break;
								}

								_context3.next = 9;
								return this.database.multi_get(args.ids, true);

							case 9:
								results = _context3.sent;

							case 10:
								removed = _.remove(results, function (o) {
									return o.type != _this.type;
								});

								if (!_.isArray(results)) {
									_context3.next = 42;
									break;
								}

								_iteratorNormalCompletion2 = true;
								_didIteratorError2 = false;
								_iteratorError2 = undefined;
								_context3.prev = 15;
								_iterator2 = results[Symbol.iterator]();

							case 17:
								if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
									_context3.next = 26;
									break;
								}

								i = _step2.value;
								_context3.next = 21;
								return this.run_hook(i, 'get', 'after', args.context);

							case 21:
								_context3.next = 23;
								return this.do_serialize(i, 'read', {}, args);

							case 23:
								_iteratorNormalCompletion2 = true;
								_context3.next = 17;
								break;

							case 26:
								_context3.next = 32;
								break;

							case 28:
								_context3.prev = 28;
								_context3.t0 = _context3['catch'](15);
								_didIteratorError2 = true;
								_iteratorError2 = _context3.t0;

							case 32:
								_context3.prev = 32;
								_context3.prev = 33;

								if (!_iteratorNormalCompletion2 && _iterator2.return) {
									_iterator2.return();
								}

							case 35:
								_context3.prev = 35;

								if (!_didIteratorError2) {
									_context3.next = 38;
									break;
								}

								throw _iteratorError2;

							case 38:
								return _context3.finish(35);

							case 39:
								return _context3.finish(32);

							case 40:
								_context3.next = 47;
								break;

							case 42:
								_i = results;
								_context3.next = 45;
								return this.run_hook(_i, 'get', 'after', args.context);

							case 45:
								_context3.next = 47;
								return this.do_serialize(_i, 'read', {}, args);

							case 47:
								console.log(results);
								return _context3.abrupt('return', results);

							case 51:
								_context3.prev = 51;
								_context3.t1 = _context3['catch'](0);

								console.log(_context3.t1.stack);
								throw _context3.t1;

							case 55:
							case 'end':
								return _context3.stop();
						}
					}
				}, _callee3, this, [[0, 51], [15, 28, 32, 40], [33,, 35, 39]]);
			}));

			function getMulti(_x4) {
				return _ref3.apply(this, arguments);
			}

			return getMulti;
		}()
	}, {
		key: 'exist',
		value: function () {
			var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(data) {
				var result;
				return regeneratorRuntime.wrap(function _callee4$(_context4) {
					while (1) {
						switch (_context4.prev = _context4.next) {
							case 0:
								_context4.prev = 0;

								if (!_.isString(data)) {
									_context4.next = 9;
									break;
								}

								_context4.next = 4;
								return this.database.get(data);

							case 4:
								result = _context4.sent;

								if (!(result.type != this.type)) {
									_context4.next = 7;
									break;
								}

								return _context4.abrupt('return', false);

							case 7:
								_context4.next = 11;
								break;

							case 9:
								if (!(data.type != this.type)) {
									_context4.next = 11;
									break;
								}

								return _context4.abrupt('return', false);

							case 11:
								return _context4.abrupt('return', true);

							case 14:
								_context4.prev = 14;
								_context4.t0 = _context4['catch'](0);
								throw _context4.t0;

							case 17:
							case 'end':
								return _context4.stop();
						}
					}
				}, _callee4, this, [[0, 14]]);
			}));

			function exist(_x5) {
				return _ref4.apply(this, arguments);
			}

			return exist;
		}()
	}, {
		key: 'update',
		value: function () {
			var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(args) {
				var results, item_exist, cover_obj;
				return regeneratorRuntime.wrap(function _callee5$(_context5) {
					while (1) {
						switch (_context5.prev = _context5.next) {
							case 0:
								_context5.prev = 0;

								this.updated_at = new SDate().now();
								//console.log("Id in update", args.id, this)
								_context5.next = 4;
								return this.database.get(args.id);

							case 4:
								results = _context5.sent;
								_context5.next = 7;
								return this.exist(results);

							case 7:
								item_exist = _context5.sent;

								if (item_exist) {
									_context5.next = 10;
									break;
								}

								throw new Error(this.type + ' does not exist.');

							case 10:
								delete results['id'];
								_.defaults(this, results);
								cover_obj = {
									old: results,
									new: this,
									id: args.id
								};

								if (!(args.skip_hooks != true)) {
									_context5.next = 16;
									break;
								}

								_context5.next = 16;
								return this.run_hook(cover_obj, 'update', 'before');

							case 16:
								if (!(args.skip_write_serialize != true && args.skip_serialize != true)) {
									_context5.next = 19;
									break;
								}

								_context5.next = 19;
								return this.do_serialize(this, 'write', cover_obj.new, args);

							case 19:
								_context5.next = 21;
								return this.database.update(args.id, this);

							case 21:
								if (!(args.skip_hooks != true)) {
									_context5.next = 24;
									break;
								}

								_context5.next = 24;
								return this.run_hook(_extends({}, this, {
									id: args.id
								}), 'update', 'after');

							case 24:
								if (!(args.skip_read_serialize != true && args.skip_serialize != true)) {
									_context5.next = 27;
									break;
								}

								_context5.next = 27;
								return this.do_serialize(this, 'read', {}, args);

							case 27:
								this.id = args.id;
								return _context5.abrupt('return', this);

							case 31:
								_context5.prev = 31;
								_context5.t0 = _context5['catch'](0);

								console.log("Error on update", _context5.t0, _context5.t0.stack);
								throw _context5.t0;

							case 35:
							case 'end':
								return _context5.stop();
						}
					}
				}, _callee5, this, [[0, 31]]);
			}));

			function update(_x6) {
				return _ref5.apply(this, arguments);
			}

			return update;
		}()
	}, {
		key: 'create',
		value: function () {
			var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(args) {
				var form, id, results;
				return regeneratorRuntime.wrap(function _callee6$(_context6) {
					while (1) {
						switch (_context6.prev = _context6.next) {
							case 0:
								_context6.prev = 0;
								form = void 0;

								this.created_at = new SDate().now();
								if (args.body) {
									form = _.defaults({}, args.body);
									form.created_at = this.created_at;
									form.updated_at = this.created_at;
									delete form['bucket'];
								}
								this.updated_at = new SDate().now();

								id = "";

								if (args && args.id) {
									id = args.id;
								} else {
									id = args.id_prefix + '-' + UUID.v4();
								}

								_context6.next = 9;
								return this.run_hook(form || this, 'create', 'before');

							case 9:
								_context6.next = 11;
								return this.do_serialize(form || this, 'write', {}, args);

							case 11:
								_context6.next = 13;
								return this.database.insert(id, form || this, args.expiry);

							case 13:
								results = _context6.sent;
								_context6.next = 16;
								return this.run_hook(_extends({}, results, {
									id: id
								}), 'create', 'after');

							case 16:
								_context6.next = 18;
								return this.do_serialize(results, 'read', {}, args);

							case 18:
								return _context6.abrupt('return', results);

							case 21:
								_context6.prev = 21;
								_context6.t0 = _context6['catch'](0);

								console.log(_context6.t0.stack);
								throw _context6.t0;

							case 25:
							case 'end':
								return _context6.stop();
						}
					}
				}, _callee6, this, [[0, 21]]);
			}));

			function create(_x7) {
				return _ref6.apply(this, arguments);
			}

			return create;
		}()
	}, {
		key: 'delete',
		value: function () {
			var _ref7 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(args) {
				var item_exist, delete_response, results;
				return regeneratorRuntime.wrap(function _callee7$(_context7) {
					while (1) {
						switch (_context7.prev = _context7.next) {
							case 0:
								_context7.next = 2;
								return this.exist(args.id);

							case 2:
								item_exist = _context7.sent;

								if (item_exist) {
									_context7.next = 5;
									break;
								}

								throw new Error(this.type + ' does not exist.');

							case 5:
								_context7.prev = 5;
								_context7.next = 8;
								return this.run_hook(args, 'delete', 'before');

							case 8:
								delete_response = {};

								if (!args.hard) {
									_context7.next = 15;
									break;
								}

								_context7.next = 12;
								return this.database.delete(args.id);

							case 12:
								delete_response = _context7.sent;
								_context7.next = 23;
								break;

							case 15:
								_context7.next = 17;
								return this.database.get(args.id);

							case 17:
								results = _context7.sent;

								delete results['id'];
								results.deleted = true;
								_context7.next = 22;
								return this.database.update(args.id, "");

							case 22:
								delete_response = _context7.sent;

							case 23:
								_context7.next = 25;
								return this.run_hook(args, 'delete', 'after');

							case 25:
								return _context7.abrupt('return', {});

							case 28:
								_context7.prev = 28;
								_context7.t0 = _context7['catch'](5);

								console.log(_context7.t0.stack);
								throw _context7.t0;

							case 32:
							case 'end':
								return _context7.stop();
						}
					}
				}, _callee7, this, [[5, 28]]);
			}));

			function _delete(_x8) {
				return _ref7.apply(this, arguments);
			}

			return _delete;
		}()
	}, {
		key: 'toString',
		value: function toString() {
			JSON.stringify(this);
		}
	}, {
		key: 'list',
		value: function () {
			var _ref8 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(args) {
				var query, results;
				return regeneratorRuntime.wrap(function _callee8$(_context8) {
					while (1) {
						switch (_context8.prev = _context8.next) {
							case 0:
								_context8.prev = 0;

								if (!args) {
									args = {};
								}

								query = "";

								if (!(args.is_full_text && args.is_full_text === "true" || args.is_custom_query && args.is_custom_query === "true")) {
									_context8.next = 7;
									break;
								}

								query = args.query;
								_context8.next = 14;
								break;

							case 7:
								if (!args.filters) {
									_context8.next = 13;
									break;
								}

								_context8.next = 10;
								return this.makeQueryFromFilter(args.filters);

							case 10:
								query = _context8.sent;
								_context8.next = 14;
								break;

							case 13:
								if (args.query) {
									query = args.query + " AND (deleted = false OR deleted IS MISSING) ";
								} else {
									query = "(deleted = false OR deleted IS MISSING) ";
								}

							case 14:

								if (args.limit) {
									args.limit = Number(args.limit);
								}
								if (args.offset) {
									args.offset = Number(args.offset);
								}

								if (!args.sort) {
									args.sort = "";
								}

								_context8.next = 19;
								return this.run_hook(this, 'get', 'before');

							case 19:
								results = void 0;

								if (!(args.is_custom_query && args.is_custom_query === "true")) {
									_context8.next = 31;
									break;
								}

								_context8.next = 23;
								return this.database.query(query);

							case 23:
								results = _context8.sent;
								_context8.next = 26;
								return this.run_hook(results, 'get', 'after');

							case 26:
								_context8.next = 28;
								return this.do_serialize(results, 'read', {}, args);

							case 28:
								return _context8.abrupt('return', results);

							case 31:
								if (!(args.is_full_text && args.is_full_text === "true")) {
									_context8.next = 37;
									break;
								}

								_context8.next = 34;
								return this.database.full_text_search(this.type, query || "", args.limit, args.offset);

							case 34:
								results = _context8.sent;
								_context8.next = 46;
								break;

							case 37:
								_context8.prev = 37;
								_context8.next = 40;
								return this.database.search(this.type, args.columns || "", query || "", args.limit, args.offset, args.sort, args.do_count, args.statement_consistent);

							case 40:
								results = _context8.sent;
								_context8.next = 46;
								break;

							case 43:
								_context8.prev = 43;
								_context8.t0 = _context8['catch'](37);

								console.log(_context8.t0.stack);

							case 46:
								_context8.prev = 46;
								_context8.next = 49;
								return this.run_hook(results.data, 'get', 'after');

							case 49:
								_context8.next = 51;
								return this.do_serialize(results.data, 'read', {}, args);

							case 51:
								_context8.next = 56;
								break;

							case 53:
								_context8.prev = 53;
								_context8.t1 = _context8['catch'](46);

								console.log(_context8.t1);

							case 56:
								return _context8.abrupt('return', results.data);

							case 57:
								_context8.next = 63;
								break;

							case 59:
								_context8.prev = 59;
								_context8.t2 = _context8['catch'](0);

								console.log(_context8.t2.stack);
								throw _context8.t2;

							case 63:
							case 'end':
								return _context8.stop();
						}
					}
				}, _callee8, this, [[0, 59], [37, 43], [46, 53]]);
			}));

			function list(_x9) {
				return _ref8.apply(this, arguments);
			}

			return list;
		}()
	}, {
		key: 'list',
		value: function () {
			var _ref9 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9(args) {
				var query, results;
				return regeneratorRuntime.wrap(function _callee9$(_context9) {
					while (1) {
						switch (_context9.prev = _context9.next) {
							case 0:
								_context9.prev = 0;

								if (!args) {
									args = {};
								}

								query = "";

								if (!(args.is_full_text && args.is_full_text === "true" || args.is_custom_query && args.is_custom_query === "true")) {
									_context9.next = 7;
									break;
								}

								query = args.query;
								_context9.next = 14;
								break;

							case 7:
								if (!args.filters) {
									_context9.next = 13;
									break;
								}

								_context9.next = 10;
								return this.makeQueryFromFilter(args.filters);

							case 10:
								query = _context9.sent;
								_context9.next = 14;
								break;

							case 13:
								if (args.query) {
									query = args.query + " AND (deleted = false OR deleted IS MISSING) ";
								} else {
									query = "(deleted = false OR deleted IS MISSING) ";
								}

							case 14:

								if (args.limit) {
									args.limit = Number(args.limit);
								}
								if (args.offset) {
									args.offset = Number(args.offset);
								}

								if (!args.sort) {
									args.sort = "created_at";
								}

								_context9.next = 19;
								return this.run_hook(this, 'get', 'before');

							case 19:
								results = void 0;

								if (!(args.is_custom_query && args.is_custom_query === "true")) {
									_context9.next = 31;
									break;
								}

								_context9.next = 23;
								return this.database.query(query);

							case 23:
								results = _context9.sent;
								_context9.next = 26;
								return this.run_hook(results, 'get', 'after');

							case 26:
								_context9.next = 28;
								return this.do_serialize(results, 'read', {}, args);

							case 28:
								return _context9.abrupt('return', results);

							case 31:
								if (!(args.is_full_text && args.is_full_text === "true")) {
									_context9.next = 37;
									break;
								}

								_context9.next = 34;
								return this.database.full_text_search(this.type, query || "", args.limit, args.offset);

							case 34:
								results = _context9.sent;
								_context9.next = 46;
								break;

							case 37:
								_context9.prev = 37;
								_context9.next = 40;
								return this.database.search(this.type, args.columns || "", query || "", args.limit, args.offset, args.sort, args.do_count, args.statement_consistent);

							case 40:
								results = _context9.sent;
								_context9.next = 46;
								break;

							case 43:
								_context9.prev = 43;
								_context9.t0 = _context9['catch'](37);

								console.log(_context9.t0.stack);

							case 46:
								_context9.prev = 46;
								_context9.next = 49;
								return this.run_hook(results.data, 'get', 'after');

							case 49:
								_context9.next = 51;
								return this.do_serialize(results.data, 'read', {}, args);

							case 51:
								_context9.next = 56;
								break;

							case 53:
								_context9.prev = 53;
								_context9.t1 = _context9['catch'](46);

								console.log(_context9.t1);

							case 56:
								if (!(results.total != null || results.total != undefined)) {
									_context9.next = 58;
									break;
								}

								return _context9.abrupt('return', results);

							case 58:
								return _context9.abrupt('return', results.data);

							case 59:
								_context9.next = 65;
								break;

							case 61:
								_context9.prev = 61;
								_context9.t2 = _context9['catch'](0);

								console.log(_context9.t2.stack);
								throw _context9.t2;

							case 65:
							case 'end':
								return _context9.stop();
						}
					}
				}, _callee9, this, [[0, 61], [37, 43], [46, 53]]);
			}));

			function list(_x10) {
				return _ref9.apply(this, arguments);
			}

			return list;
		}()
	}, {
		key: 'run_hook',
		value: function () {
			var _ref10 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10(data, op, when, old_data) {
				var _iteratorNormalCompletion3, _didIteratorError3, _iteratorError3, _iterator3, _step3, i;

				return regeneratorRuntime.wrap(function _callee10$(_context10) {
					while (1) {
						switch (_context10.prev = _context10.next) {
							case 0:
								_context10.prev = 0;

								if (!(this.hooks && this.hooks()[op] && this.hooks()[op][when])) {
									_context10.next = 35;
									break;
								}

								if (!_.isArray(this.hooks()[op][when])) {
									_context10.next = 32;
									break;
								}

								_iteratorNormalCompletion3 = true;
								_didIteratorError3 = false;
								_iteratorError3 = undefined;
								_context10.prev = 6;
								_iterator3 = this.hooks()[op][when][Symbol.iterator]();

							case 8:
								if (_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done) {
									_context10.next = 16;
									break;
								}

								i = _step3.value;
								_context10.next = 12;
								return i(data, old_data);

							case 12:
								data = _context10.sent;

							case 13:
								_iteratorNormalCompletion3 = true;
								_context10.next = 8;
								break;

							case 16:
								_context10.next = 22;
								break;

							case 18:
								_context10.prev = 18;
								_context10.t0 = _context10['catch'](6);
								_didIteratorError3 = true;
								_iteratorError3 = _context10.t0;

							case 22:
								_context10.prev = 22;
								_context10.prev = 23;

								if (!_iteratorNormalCompletion3 && _iterator3.return) {
									_iterator3.return();
								}

							case 25:
								_context10.prev = 25;

								if (!_didIteratorError3) {
									_context10.next = 28;
									break;
								}

								throw _iteratorError3;

							case 28:
								return _context10.finish(25);

							case 29:
								return _context10.finish(22);

							case 30:
								_context10.next = 35;
								break;

							case 32:
								_context10.next = 34;
								return this.hooks()[op][when](data, old_data);

							case 34:
								data = _context10.sent;

							case 35:
								return _context10.abrupt('return', data);

							case 38:
								_context10.prev = 38;
								_context10.t1 = _context10['catch'](0);
								throw _context10.t1;

							case 41:
							case 'end':
								return _context10.stop();
						}
					}
				}, _callee10, this, [[0, 38], [6, 18, 22, 30], [23,, 25, 29]]);
			}));

			function run_hook(_x11, _x12, _x13, _x14) {
				return _ref10.apply(this, arguments);
			}

			return run_hook;
		}()

		/*async run_hook(data, obj, context){
  	try{
  
  		if(obj) {
  			if (_.isArray(obj)) {
  				for (var i of obj) {
  					await i.apply(this, [data, context]);
  				}
  			} else if (_.isFunction(obj)) {
  				await obj.apply(this, [data, context]);
  			}
  		}
  	}catch (e){
  		console.log(e.stack);
  	}
  }*/

	}, {
		key: 'defaultCleaners',
		value: function defaultCleaners() {
			var _this2 = this;

			return [function () {
				var _ref11 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11(data) {
					var _iteratorNormalCompletion4, _didIteratorError4, _iteratorError4, _iterator4, _step4, i;

					return regeneratorRuntime.wrap(function _callee11$(_context11) {
						while (1) {
							switch (_context11.prev = _context11.next) {
								case 0:
									_context11.prev = 0;

									if (!_.isArray(data)) {
										_context11.next = 23;
										break;
									}

									_iteratorNormalCompletion4 = true;
									_didIteratorError4 = false;
									_iteratorError4 = undefined;
									_context11.prev = 5;

									for (_iterator4 = data[Symbol.iterator](); !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
										i = _step4.value;

										delete i['deleted'];
										delete i['type'];
									}
									_context11.next = 13;
									break;

								case 9:
									_context11.prev = 9;
									_context11.t0 = _context11['catch'](5);
									_didIteratorError4 = true;
									_iteratorError4 = _context11.t0;

								case 13:
									_context11.prev = 13;
									_context11.prev = 14;

									if (!_iteratorNormalCompletion4 && _iterator4.return) {
										_iterator4.return();
									}

								case 16:
									_context11.prev = 16;

									if (!_didIteratorError4) {
										_context11.next = 19;
										break;
									}

									throw _iteratorError4;

								case 19:
									return _context11.finish(16);

								case 20:
									return _context11.finish(13);

								case 21:
									_context11.next = 25;
									break;

								case 23:
									delete data['deleted'];
									delete data['type'];

								case 25:
									return _context11.abrupt('return', data);

								case 28:
									_context11.prev = 28;
									_context11.t1 = _context11['catch'](0);
									throw _context11.t1;

								case 31:
								case 'end':
									return _context11.stop();
							}
						}
					}, _callee11, _this2, [[0, 28], [5, 9, 13, 21], [14,, 16, 20]]);
				}));

				return function (_x15) {
					return _ref11.apply(this, arguments);
				};
			}()];
		}
	}, {
		key: 'defaultModifiers',
		value: function defaultModifiers() {
			var _this3 = this;

			return [function () {
				var _ref12 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee12(data) {
					return regeneratorRuntime.wrap(function _callee12$(_context12) {
						while (1) {
							switch (_context12.prev = _context12.next) {
								case 0:
									_context12.prev = 0;
									return _context12.abrupt('return', data);

								case 4:
									_context12.prev = 4;
									_context12.t0 = _context12['catch'](0);
									throw _context12.t0;

								case 7:
								case 'end':
									return _context12.stop();
							}
						}
					}, _callee12, _this3, [[0, 4]]);
				}));

				return function (_x16) {
					return _ref12.apply(this, arguments);
				};
			}()];
		}
	}, {
		key: 'serializer',
		value: function serializer() {
			var _this4 = this;

			return {
				read: {
					modifiers: [
						/*async (data)=>{
      	try{
      		if(_.isArray(data)){
      			//modifiers for arrays
      			}else{
      				//modifiers for single
      		}
      		return data;
      	}catch(e){
      		throw new Error(e);
      	}
      }*/
					],
					cleaners: [
						//this is the default cleaner is none is specifier. add cleaner to override the default
						/*async (data)=>{
      	try{
      		if(_.isArray(data)){
      			for(let i of data){
      				delete i['deleted'];
      				delete i['type'];
      			}
      		}else{
      			delete data['deleted'];
      			delete data['type'];
      		}
      		return data;
      	}catch(e){
      		throw new Error(e);
      	}
      }*/
					]
				},
				write: {
					modifiers: [function () {
						var _ref13 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee13(data) {
							return regeneratorRuntime.wrap(function _callee13$(_context13) {
								while (1) {
									switch (_context13.prev = _context13.next) {
										case 0:
											_context13.prev = 0;
											return _context13.abrupt('return', data);

										case 4:
											_context13.prev = 4;
											_context13.t0 = _context13['catch'](0);
											throw _context13.t0;

										case 7:
										case 'end':
											return _context13.stop();
									}
								}
							}, _callee13, _this4, [[0, 4]]);
						}));

						return function (_x17) {
							return _ref13.apply(this, arguments);
						};
					}()],
					cleaners: [function () {
						var _ref14 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee14(data) {
							return regeneratorRuntime.wrap(function _callee14$(_context14) {
								while (1) {
									switch (_context14.prev = _context14.next) {
										case 0:
											_context14.prev = 0;
											return _context14.abrupt('return', data);

										case 4:
											_context14.prev = 4;
											_context14.t0 = _context14['catch'](0);
											throw _context14.t0;

										case 7:
										case 'end':
											return _context14.stop();
									}
								}
							}, _callee14, _this4, [[0, 4]]);
						}));

						return function (_x18) {
							return _ref14.apply(this, arguments);
						};
					}()]
				}
			};
		}
	}, {
		key: 'hooks',
		value: function hooks() {
			var _this5 = this;

			return {
				create: {
					before: function () {
						var _ref15 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee15(data) {
							return regeneratorRuntime.wrap(function _callee15$(_context15) {
								while (1) {
									switch (_context15.prev = _context15.next) {
										case 0:
											_context15.prev = 0;
											return _context15.abrupt('return', data);

										case 4:
											_context15.prev = 4;
											_context15.t0 = _context15['catch'](0);
											throw _context15.t0;

										case 7:
										case 'end':
											return _context15.stop();
									}
								}
							}, _callee15, _this5, [[0, 4]]);
						}));

						return function before(_x19) {
							return _ref15.apply(this, arguments);
						};
					}(),
					after: function () {
						var _ref16 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee16(data) {
							return regeneratorRuntime.wrap(function _callee16$(_context16) {
								while (1) {
									switch (_context16.prev = _context16.next) {
										case 0:
											_context16.prev = 0;
											return _context16.abrupt('return', data);

										case 4:
											_context16.prev = 4;
											_context16.t0 = _context16['catch'](0);
											throw _context16.t0;

										case 7:
										case 'end':
											return _context16.stop();
									}
								}
							}, _callee16, _this5, [[0, 4]]);
						}));

						return function after(_x20) {
							return _ref16.apply(this, arguments);
						};
					}()
				},
				get: {
					before: function () {
						var _ref17 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee17(data) {
							return regeneratorRuntime.wrap(function _callee17$(_context17) {
								while (1) {
									switch (_context17.prev = _context17.next) {
										case 0:
											_context17.prev = 0;
											return _context17.abrupt('return', data);

										case 4:
											_context17.prev = 4;
											_context17.t0 = _context17['catch'](0);
											throw _context17.t0;

										case 7:
										case 'end':
											return _context17.stop();
									}
								}
							}, _callee17, _this5, [[0, 4]]);
						}));

						return function before(_x21) {
							return _ref17.apply(this, arguments);
						};
					}(),
					after: function () {
						var _ref18 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee18(data) {
							return regeneratorRuntime.wrap(function _callee18$(_context18) {
								while (1) {
									switch (_context18.prev = _context18.next) {
										case 0:
											_context18.prev = 0;
											return _context18.abrupt('return', data);

										case 4:
											_context18.prev = 4;
											_context18.t0 = _context18['catch'](0);
											throw _context18.t0;

										case 7:
										case 'end':
											return _context18.stop();
									}
								}
							}, _callee18, _this5, [[0, 4]]);
						}));

						return function after(_x22) {
							return _ref18.apply(this, arguments);
						};
					}()
				},
				update: {
					before: function () {
						var _ref19 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee19(data) {
							return regeneratorRuntime.wrap(function _callee19$(_context19) {
								while (1) {
									switch (_context19.prev = _context19.next) {
										case 0:
											_context19.prev = 0;
											return _context19.abrupt('return', data);

										case 4:
											_context19.prev = 4;
											_context19.t0 = _context19['catch'](0);
											throw _context19.t0;

										case 7:
										case 'end':
											return _context19.stop();
									}
								}
							}, _callee19, _this5, [[0, 4]]);
						}));

						return function before(_x23) {
							return _ref19.apply(this, arguments);
						};
					}(),
					after: function () {
						var _ref20 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee20(data) {
							return regeneratorRuntime.wrap(function _callee20$(_context20) {
								while (1) {
									switch (_context20.prev = _context20.next) {
										case 0:
											_context20.prev = 0;
											return _context20.abrupt('return', data);

										case 4:
											_context20.prev = 4;
											_context20.t0 = _context20['catch'](0);
											throw _context20.t0;

										case 7:
										case 'end':
											return _context20.stop();
									}
								}
							}, _callee20, _this5, [[0, 4]]);
						}));

						return function after(_x24) {
							return _ref20.apply(this, arguments);
						};
					}()
				},
				delete: {
					before: function () {
						var _ref21 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee21(data) {
							return regeneratorRuntime.wrap(function _callee21$(_context21) {
								while (1) {
									switch (_context21.prev = _context21.next) {
										case 0:
											_context21.prev = 0;
											return _context21.abrupt('return', data);

										case 4:
											_context21.prev = 4;
											_context21.t0 = _context21['catch'](0);
											throw _context21.t0;

										case 7:
										case 'end':
											return _context21.stop();
									}
								}
							}, _callee21, _this5, [[0, 4]]);
						}));

						return function before(_x25) {
							return _ref21.apply(this, arguments);
						};
					}(),
					after: function () {
						var _ref22 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee22(data) {
							return regeneratorRuntime.wrap(function _callee22$(_context22) {
								while (1) {
									switch (_context22.prev = _context22.next) {
										case 0:
											_context22.prev = 0;
											return _context22.abrupt('return', data);

										case 4:
											_context22.prev = 4;
											_context22.t0 = _context22['catch'](0);
											throw _context22.t0;

										case 7:
										case 'end':
											return _context22.stop();
									}
								}
							}, _callee22, _this5, [[0, 4]]);
						}));

						return function after(_x26) {
							return _ref22.apply(this, arguments);
						};
					}()
				}
			};
		}
	}, {
		key: 'shouldSerializerRun',
		value: function shouldSerializerRun(args, type) {
			//console.log(args);
			if (args) {
				if (args.skip_serialize == true) {
					return false;
				}
				if (type == 'read') {
					if (args.skip_read_serialize == true) {
						return false;
					}
				} else if (type == 'write') {
					if (args.skip_write_serialize == true) {
						return false;
					}
				}
			}
			return true;
		}
	}, {
		key: 'do_serialize',
		value: function () {
			var _ref23 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee23(data, type, old_data, args) {
				var serializer_obj, active_modifiers, _iteratorNormalCompletion5, _didIteratorError5, _iteratorError5, _iterator5, _step5, i, active_cleaners, _iteratorNormalCompletion6, _didIteratorError6, _iteratorError6, _iterator6, _step6, _i2, defaults, _i3, _iteratorNormalCompletion7, _didIteratorError7, _iteratorError7, _iterator7, _step7, _i4;

				return regeneratorRuntime.wrap(function _callee23$(_context23) {
					while (1) {
						switch (_context23.prev = _context23.next) {
							case 0:
								_context23.prev = 0;

								if (!this.shouldSerializerRun(args, type)) {
									_context23.next = 120;
									break;
								}

								serializer_obj = this.serializer();
								active_modifiers = serializer_obj[type]['modifiers'];

								if (active_modifiers) {
									_context23.next = 7;
									break;
								}

								_context23.next = 7;
								return this.defaultModifiers();

							case 7:
								if (!active_modifiers) {
									_context23.next = 47;
									break;
								}

								if (!_.isArray(active_modifiers)) {
									_context23.next = 44;
									break;
								}

								_iteratorNormalCompletion5 = true;
								_didIteratorError5 = false;
								_iteratorError5 = undefined;
								_context23.prev = 12;
								_iterator5 = active_modifiers[Symbol.iterator]();

							case 14:
								if (_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done) {
									_context23.next = 28;
									break;
								}

								i = _step5.value;
								_context23.prev = 16;
								_context23.next = 19;
								return i(data, old_data);

							case 19:
								data = _context23.sent;
								_context23.next = 25;
								break;

							case 22:
								_context23.prev = 22;
								_context23.t0 = _context23['catch'](16);

								console.log(_context23.t0.stack);

							case 25:
								_iteratorNormalCompletion5 = true;
								_context23.next = 14;
								break;

							case 28:
								_context23.next = 34;
								break;

							case 30:
								_context23.prev = 30;
								_context23.t1 = _context23['catch'](12);
								_didIteratorError5 = true;
								_iteratorError5 = _context23.t1;

							case 34:
								_context23.prev = 34;
								_context23.prev = 35;

								if (!_iteratorNormalCompletion5 && _iterator5.return) {
									_iterator5.return();
								}

							case 37:
								_context23.prev = 37;

								if (!_didIteratorError5) {
									_context23.next = 40;
									break;
								}

								throw _iteratorError5;

							case 40:
								return _context23.finish(37);

							case 41:
								return _context23.finish(34);

							case 42:
								_context23.next = 47;
								break;

							case 44:
								_context23.next = 46;
								return active_modifiers(data, old_data);

							case 46:
								data = _context23.sent;

							case 47:
								//apply cleaners
								active_cleaners = serializer_obj[type]['cleaners'];

								if (!(type == 'read')) {
									_context23.next = 60;
									break;
								}

								if (active_cleaners) {
									_context23.next = 55;
									break;
								}

								_context23.next = 52;
								return this.defaultCleaners();

							case 52:
								active_cleaners = _context23.sent;
								_context23.next = 60;
								break;

							case 55:
								if (!_.isArray(active_cleaners)) {
									_context23.next = 60;
									break;
								}

								if (!(active_cleaners.length == 0)) {
									_context23.next = 60;
									break;
								}

								_context23.next = 59;
								return this.defaultCleaners();

							case 59:
								active_cleaners = _context23.sent;

							case 60:
								if (!active_cleaners) {
									_context23.next = 94;
									break;
								}

								if (!_.isArray(active_cleaners)) {
									_context23.next = 91;
									break;
								}

								_iteratorNormalCompletion6 = true;
								_didIteratorError6 = false;
								_iteratorError6 = undefined;
								_context23.prev = 65;
								_iterator6 = active_cleaners[Symbol.iterator]();

							case 67:
								if (_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done) {
									_context23.next = 75;
									break;
								}

								_i2 = _step6.value;
								_context23.next = 71;
								return _i2(data);

							case 71:
								data = _context23.sent;

							case 72:
								_iteratorNormalCompletion6 = true;
								_context23.next = 67;
								break;

							case 75:
								_context23.next = 81;
								break;

							case 77:
								_context23.prev = 77;
								_context23.t2 = _context23['catch'](65);
								_didIteratorError6 = true;
								_iteratorError6 = _context23.t2;

							case 81:
								_context23.prev = 81;
								_context23.prev = 82;

								if (!_iteratorNormalCompletion6 && _iterator6.return) {
									_iterator6.return();
								}

							case 84:
								_context23.prev = 84;

								if (!_didIteratorError6) {
									_context23.next = 87;
									break;
								}

								throw _iteratorError6;

							case 87:
								return _context23.finish(84);

							case 88:
								return _context23.finish(81);

							case 89:
								_context23.next = 94;
								break;

							case 91:
								_context23.next = 93;
								return active_cleaners(data);

							case 93:
								data = _context23.sent;

							case 94:

								//get defaults from peroperties
								defaults = {};

								if (this.props) {
									for (_i3 in this.props) {
										if (this.props[_i3].defaults != undefined && this.props[_i3].defaults[type] != undefined) {
											defaults[_i3] = this.props[_i3].defaults[type];
										}
									}
								}

								//apply defaults

								if (!_.isArray(data)) {
									_context23.next = 118;
									break;
								}

								_iteratorNormalCompletion7 = true;
								_didIteratorError7 = false;
								_iteratorError7 = undefined;
								_context23.prev = 100;

								for (_iterator7 = data[Symbol.iterator](); !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
									_i4 = _step7.value;

									_.defaults(_i4, defaults);
								}
								_context23.next = 108;
								break;

							case 104:
								_context23.prev = 104;
								_context23.t3 = _context23['catch'](100);
								_didIteratorError7 = true;
								_iteratorError7 = _context23.t3;

							case 108:
								_context23.prev = 108;
								_context23.prev = 109;

								if (!_iteratorNormalCompletion7 && _iterator7.return) {
									_iterator7.return();
								}

							case 111:
								_context23.prev = 111;

								if (!_didIteratorError7) {
									_context23.next = 114;
									break;
								}

								throw _iteratorError7;

							case 114:
								return _context23.finish(111);

							case 115:
								return _context23.finish(108);

							case 116:
								_context23.next = 119;
								break;

							case 118:
								_.defaults(data, defaults);

							case 119:
								return _context23.abrupt('return', data);

							case 120:
								_context23.next = 126;
								break;

							case 122:
								_context23.prev = 122;
								_context23.t4 = _context23['catch'](0);

								console.log(_context23.t4.stack);
								throw _context23.t4;

							case 126:
							case 'end':
								return _context23.stop();
						}
					}
				}, _callee23, this, [[0, 122], [12, 30, 34, 42], [16, 22], [35,, 37, 41], [65, 77, 81, 89], [82,, 84, 88], [100, 104, 108, 116], [109,, 111, 115]]);
			}));

			function do_serialize(_x27, _x28, _x29, _x30) {
				return _ref23.apply(this, arguments);
			}

			return do_serialize;
		}()
	}, {
		key: 'database',
		get: function get() {
			return this[_database];
		},
		set: function set(value) {
			this[_database] = value;
		}
	}, {
		key: 'props',
		get: function get() {
			return this[_props];
		},
		set: function set(value) {
			this[_props] = value;
		}
	}]);

	return SpiceModel;
}();

exports.default = SpiceModel;