"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var RestHelper = function () {
    function RestHelper() {
        _classCallCheck(this, RestHelper);
    }

    _createClass(RestHelper, null, [{
        key: "prepare_collection",
        value: function prepare_collection(status, data, total) {
            var data = {
                status: status,
                type: "collection",
                count: data.length,
                data: data,
                total: total
            };
            return data;
        }
    }, {
        key: "prepare_response",
        value: function prepare_response(status, data, errors, token) {
            var response = {
                status: status,
                type: "single"
            };

            if (token) {
                response.token = token;
            }

            if (status == this.FAILURE) {
                response.message = data;
                if (errors) {
                    response.errors = errors;
                }
            } else {
                if (data) {
                    response.data = data;
                }
            }

            return response;
        }
    }, {
        key: "get_typed_value",
        value: function get_typed_value(value) {
            var returnValue;
            try {
                returnValue = Number(value);
                if (isNaN(returnValue)) {
                    throw returnValue;
                } else {
                    return returnValue;
                }
            } catch (error) {
                try {
                    if (value.toLowerCase() == "true" || value.toLowerCase() == "false") {
                        returnValue = value === 'true';
                        return returnValue;
                    } else {
                        throw Error;
                    }
                } catch (error) {
                    try {
                        returnValue = JSON.parse(value);
                        return returnValue;
                    } catch (error) {
                        try {
                            returnValue = String(value);
                            return returnValue;
                        } catch (error) {
                            console.log("Cant parse" + value);
                        }
                    }
                }
            }
        }
    }, {
        key: "normalizePort",
        value: function normalizePort(val) {
            var port = parseInt(val, 10);

            if (isNaN(port)) {
                // named pipe
                return val;
            }

            if (port >= 0) {
                // port number
                return port;
            }

            return false;
        }
    }]);

    return RestHelper;
}();

RestHelper.SUCCESS = 'SUCCESS';
RestHelper.FAILURE = "FAILURE";
exports.default = RestHelper;