var path = require('path');
var _ = require('lodash');
var program = null;

function action(controller, otherControllers) {
    try{
        let fs = require('fs');
        let src = path.join(path.resolve(__dirname+'/../'),'make_templates/Controller.js');
        let dest = path.join(path.resolve('./'),'core/server/controllers/');

        if (!fs.existsSync(src)) {
            console.log('src not found', src);
            return false;
        }
        var raw_text = fs.readFileSync(src, 'utf-8');
        var data = {
            module: controller,
            object: controller.toLowerCase(),
            single_param: `${controller.toLowerCase()}_id`,
            id_prefix: controller.toLowerCase()
        }
        var compiled = _.template(raw_text);
        var processed_template = compiled(data);
        fs.writeFileSync(dest+controller.toLowerCase()+'.js', processed_template);
        console.log("Done creating controller %s",controller);
    }catch(e){
        console.log(e.stack);
    }
}

function command(prog) {
    'use strict';
    program = prog;
    program
        .version('0.0.1')
        .command('make::controller <controller> [otherControllers...]')
        .action(action);
}



module.exports = {
    command: command,
    action: action
};