var program = require('commander');
var path = require('path');
var _ = require('lodash');
var pluralize = require('pluralize');

function action(mail, otherMails) {
    console.log('make::mail %s', mail);
    let fs = require('fs-extra');
    let src = path.join(path.resolve(__dirname+'/../'),'make_templates/mail.js');
    let dest = path.join(path.resolve('./'),'core/server/mail');
    //console.log('Dir', src);
    if (!fs.existsSync(src)) {
        console.log('src not found', src);
        return false;
    }
    var raw_text = fs.readFileSync(src, 'utf-8');
    var data = {
        mail: mail,
        plural_mail: pluralize(mail.toLowerCase()),
    }
    var compiled = _.template(raw_text);
    var processed_template = compiled(data);
    //console.log(processed_template);
    fs.ensureDirSync(dest);
    fs.writeFileSync(dest+'/'+mail+'.js', processed_template);
    console.log("Done creating mail %s",mail);
}

function command(prog) {
    'use strict';
    program = prog;
    program
        .version('0.0.1')
        .command('make::mail <mail> [otherMails...]')
        .action(action);
}

module.exports = {
    command: command,
    action: action
};