var program = null;
var path = require('path');
var _ = require('lodash');

function action(model, otherModels) {
    try{
        console.log('make::model %s', model);
        let fs = require('fs');
        let src = path.join(path.resolve(__dirname+'/../'),'make_templates/Model.js');
        let dest = path.join(path.resolve('./'),'core/server/models/');
        if (!fs.existsSync(src)) {
            console.log('src not found', src);
            return false;
        }
        var raw_text = fs.readFileSync(src, 'utf-8');
        var data = {
            connection: 'default',
            class_name: model,
            type: model.toLowerCase()
        }
        var compiled = _.template(raw_text);
        var processed_template = compiled(data);
        fs.writeFileSync(dest+model+'.js', processed_template);
        console.log("Done creating model %s",model);
    }catch(e){
        console.log(e.stack);
    }
}

function command(prog) {
    'use strict';
    program = prog;
    program
        .version('0.0.1')
        .command('make::model <model> [otherModels...]')
        .action(action);
}

module.exports = {
    command: command,
    action: action
};