var program = null;
var controller = require('./make::controller').action;
var model = require('./make::model').action;
var route = require('./make::route').action;
var service = require('./make::service').action;

function action(resource, otherResources) {
    try{
        controller(resource, otherResources);
        model(resource, otherResources);
        route(resource, otherResources);
        service(resource, otherResources);
    }catch(e){
        console.log(e.stack);
    }
}

function command(prog) {
    'use strict';
    program = prog;
    program
        .version('0.0.1')
        .command('make::resource <resource> [otherResources...]')
        .action(action);
}

module.exports = {
    command: command,
    action: action
};