var program = require('commander');
var path = require('path');
var _ = require('lodash');
var pluralize = require('pluralize');

function action(route, otherRoutes) {
    console.log('make::route %s', route);
    let fs = require('fs');
    let src = path.join(path.resolve(__dirname+'/../'),'make_templates/Route.js');
    let dest = path.join(path.resolve('./'),'core/server/routes/');
    if (!fs.existsSync(src)) {
        console.log('src not found', src);
        return false;
    }
    var raw_text = fs.readFileSync(src, 'utf-8');
    var data = {
        single_route: `${route.toLowerCase()}_id`,
        route: route.toLowerCase(),
        plural_route: pluralize(route.toLowerCase()),
    }
    var compiled = _.template(raw_text);
    var processed_template = compiled(data);
    fs.writeFileSync(dest+route.toLowerCase()+'.js', processed_template);
    console.log("Done creating route %s",route);
}

function command(prog) {
    'use strict';
    program = prog;
    program
        .version('0.0.1')
        .command('make::route <route> [otherRoutes...]')
        .action(action);
}

module.exports = {
    command: command,
    action: action
};