var program = require('commander');
var path = require('path');
var _ = require('lodash');
var pluralize = require('pluralize');

function action(service, otherServices) {
    console.log('make::service %s', service);
    let fs = require('fs');
    let src = path.join(path.resolve(__dirname+'/../'),'make_templates/Service.js');
    let dest = path.join(path.resolve('./'),'core/client/resource/assets/js/api/');
    //console.log('Dir', src);
    if (!fs.existsSync(src)) {
        console.log('src not found', src);
        return false;
    }
    var raw_text = fs.readFileSync(src, 'utf-8');
    var data = {
        service: service,
        plural_service: pluralize(service.toLowerCase()),
    }
    var compiled = _.template(raw_text);
    var processed_template = compiled(data);
    //console.log(processed_template);
    fs.writeFileSync(dest+service+'.js', processed_template);
    console.log("Done creating service %s",service);
}

function command(prog) {
    'use strict';
    program = prog;
    program
        .version('0.0.1')
        .command('make::service <service> [otherServices...]')
        .action(action);
}

module.exports = {
    command: command,
    action: action
};