'use strict';
spice.database = {};
spice.database.connections = {};

(async function connect() {
    try {
        for (let key in spice.config.database.connections) {
            let value = spice.config.database.connections[key];
            if (value.enabled) {
                let Database = require(`spice-${value.type}`);
                let connection = new Database();
                let result = await connection.connect(key, value);
                spice.database.connections[result.connection] = result.bucket;
            }
        }
    } catch (e) {
        console.log(e.stack);
        throw e;
    }

})();