import path from 'path';
import fs from 'fs';
import _ from 'lodash';

let ordered_modules=[
    'logger',
    'error',
    'database',
    'views'
]
export default async function(){
    try {
        /*console.log('loading from array')*/
        let bootstrap_path = path.resolve(path.join(spice.module_root_path,'/bootstrap'));
        let app_bootstrap_path = path.resolve(path.join(spice.root_path,'/bootstrap'));
        /*console.log('Bootstrap directory', bootstrap_path);*/

        for (let file of ordered_modules) {
            let mod = require(path.join(bootstrap_path, file))
            if (_.isFunction(mod)) {
                await mod();
            }
            console.log('loaded', file);
        }

        let paths = [bootstrap_path, app_bootstrap_path];

        for(let loadder_path of paths){
            /*console.log('loading from directory');*/
            for (let file of fs.readdirSync(loadder_path)) {
                if (file != 'index.js' && !(_.includes(ordered_modules, file.split('.')[0]))) {
                    let mod =  require(path.join(loadder_path, file.split('.')[0]));
                    if(_.isFunction(mod)){
                        await mod();
                    }
                    /*console.log('file loaded', file)*/
                }
            }
        }

    } catch (e) {
        console.log(e.stack);
    }
}();
