let fs = require('fs-extra');
var path = require('path');
var open = require("open");

export default class File{
    
	constructor(args={}){
        this.sender = args.sender;
        this.subject = args.subject;
        this.htmlText = args.htmlText;
        this.dest = path.join(path.resolve('./'),'storage/mail');
        if(args.path){
            this.dest = path.resolve(args.path)
        }
    }

    async send(htmlText, options={}){

        let email = {
            to: options.to,
            from: options.sender || this.sender,
            subject: options.subject || this.subject,
            htmlText: htmlText || this.htmlText
        }
        
        let time = new Date().getTime();
        fs.ensureDirSync(`${this.dest}/${email.subject}/${time}`);
        let full_path = `${this.dest}/${email.subject}/${time}/to:${email.to} from:${email.from}.html`;
        fs.writeFileSync(full_path, email.htmlText);
        open(full_path);
    }
}