"use strict";
/**
 * Created by chadfraser on 12/12/15.
 */

var crypto = require("crypto");

class Crypt{
    constructor(){
        this.salt  = "";
        this.hash = "";
    }

    async encrypt (value){
        let that = this;
        return new Promise(async (resolve, reject)=>{
            try{
                if(!value){
                    reject(new Error('Value must not be empty'))
                }
                var salt = await that.generateRandumString(128);
                var hash_obj = await that.findHash(value, salt);
                resolve(hash_obj);
            }catch(e){
                reject(e);
            }
        });
    }


    async generateRandumString(length){
        return new Promise(async (resolve, reject)=>{
            if(!length){
                length = 64;
            }
            crypto.randomBytes(length, function (err, bytes) {
                if (err) {
                    reject(err);
                }
                var ran_bytes = new Buffer(bytes).toString('hex');
                resolve(ran_bytes);
            });
        });
    }


    async findHash(value, salt){
        try{
            return new Promise(async(resolve, reject)=>{
                crypto.pbkdf2(value, salt, 7000, 256, 'sha512',
                (err, hash) => {
                    if (err) {
                        reject(err);
                    }
                    var object = {};
                    object.hash = new Buffer(hash).toString('hex');
                    object.salt = salt;
                    resolve(object);
                });
            });
        }catch(e){
            return Promise.reject(e);
        }
    }
}
module.exports = Crypt;