

export default class RestHelper{
    constructor(){

    }

    static SUCCESS = 'SUCCESS'
    static FAILURE = "FAILURE";
    static prepare_collection(status, data, total){
        var data = {
            status: status,
            type: "collection",
            count: data.length,
            data: data,
            total: total
        }
        return data;
    }

    static prepare_response(status, data, errors, token){
        var response  = {
            status: status,
            type:"single"
        }

        if(token){
            response.token = token;
        }

        if(status == this.FAILURE){
            response.message = data;
            if(errors){
                response.errors = errors;
            }
        }else{
            if(data) {
                response.data = data;
            }
        }

        return response;
    }

    static get_typed_value(value){
        var returnValue;
        try{
            returnValue = Number(value)
            if(isNaN(returnValue)){
                throw returnValue;
            }else{
                return returnValue;
            }

        }catch (error){
            try{
                if(value.toLowerCase() == "true" || value.toLowerCase() == "false"){
                    returnValue = (value === 'true');
                    return returnValue;
                }else{
                    throw Error;
                }
            }catch (error){
                try{
                    returnValue = JSON.parse(value);
                    return returnValue;
                }catch (error){
                    try{
                        returnValue = String(value);
                        return returnValue;
                    }catch (error){
                        console.log("Cant parse"+ value);
                    }
                }
            }
        }
    }

    static normalizePort(val) {
        var port = parseInt(val, 10);

        if (isNaN(port)) {
            // named pipe
            return val;
        }

        if (port >= 0) {
            // port number
            return port;
        }

        return false;
    }

}