/**
 * Created by chadfraser on 23/06/2016.
 */
'use strict';
let _ = require('lodash');
export default class Serializer{
    constructor(params){
        if(params){
            if(params.defaults){
                this.defaults = params.defaults;
            }
            if(params.modifier){
                this.modifier = params.modifier;
            }
        }
    }
    serialize(item){
        try{
            if(this.defaults){
                _.defaults(item, this.defaults);
            }
            if(this.modifier){
                if(_.isFunction(this.modifier)){
                    this.modifier(item)
                }
            }
        }catch (e){
            console.log(e.stack);
        }
    }

    handle(params){
        if(params){
            if(_.isArray(params)){
                for(let item of params){
                    this.serialize(item);
                }
            }else{
                this.serialize(params);
            }
        }
    }
}